<?php

ini_set("display_errors", "true");

    // define the entry point
if (!defined( "PLOG_CLASS_PATH" )) {
    $path = dirname(__FILE__);
    $pos = strpos($path, "moblog");
    if($pos !== FALSE){
            // get path to root, ie. strip off "plugins/moblog/install"
            // don't search for '/' since windows uses '\\'
        $path = substr($path, 0, $pos-8);
    }
    define( "PLOG_CLASS_PATH", $path."/");
}
    
    //
    // set this to false if you want logging enabled
    //
define( "MOBLOG_DEBUG", true );

    // bring in some code that we need
include_once( PLOG_CLASS_PATH."class/bootstrap.php" );    
lt_include( PLOG_CLASS_PATH."class/dao/blogs.class.php" );
lt_include( PLOG_CLASS_PATH."class/dao/users.class.php" );
lt_include( PLOG_CLASS_PATH."class/file/file.class.php" );
lt_include( PLOG_CLASS_PATH."class/data/timestamp.class.php" );
lt_include( PLOG_CLASS_PATH."class/net/http/httpvars.class.php" );
lt_include( PLOG_CLASS_PATH."class/dao/articles.class.php" );
lt_include( PLOG_CLASS_PATH."class/data/timestamp.class.php" );
lt_include( PLOG_CLASS_PATH."class/config/config.class.php" );
lt_include( PLOG_CLASS_PATH."class/gallery/dao/galleryresources.class.php" );
lt_include( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );
lt_include( PLOG_CLASS_PATH."plugins/moblog/class/log/mobloglogger.class.php" );
lt_include( PLOG_CLASS_PATH."plugins/moblog/class/moblog/moblogrequest.class.php" );
lt_include( PLOG_CLASS_PATH."plugins/moblog/class/moblog/moblogresponse.class.php" );
lt_include( PLOG_CLASS_PATH."plugins/moblog/class/moblog/moblogconstants.properties.php" );
lt_include( PLOG_CLASS_PATH."class/template/cachecontrol.class.php" ); 
lt_include( PLOG_CLASS_PATH."class/dao/userpermissions.class.php" );
lt_include( PLOG_CLASS_PATH."class/dao/articlecategories.class.php" );
lt_include( PLOG_CLASS_PATH."class/dao/globalarticlecategories.class.php" );
lt_include( PLOG_CLASS_PATH."class/dao/articlenotifications.class.php" );	
lt_include( PLOG_CLASS_PATH."class/file/fileupload.class.php" );
lt_include( PLOG_CLASS_PATH."class/plugin/pluginmanager.class.php" );

    // initialize the logging system
MoblogLogger::log( "-- Initialized");

    // get the request
$request = HttpVars::getRequest();
isset( $request["message"] ) ? $message = $request["message"] : $message = "";
    
if( $message == "" ) {
    MoblogLogger::log( "There was no message!" );
    die();
}
    
    // check if we need to remove any quotes..
if( get_magic_quotes_gpc()) {
    $message = stripslashes( $message );
}

MoblogLogger::log("-- message --");
MoblogLogger::log($message);
MoblogLogger::log("-- message end --");
    
    // parse the message
$request = new MoblogRequest( $request );
    
    // let's see what we get...    
MoblogLogger::log( "user = '".$request->getUser()."'");
    // uncomment the following if you want to see passwords... :)
    //MoblogLogger::log( "pass = '".$request->getPassword()."'");
MoblogLogger::log( "blog id = ".$request->getBlogId());
MoblogLogger::log( "blog name = ".$request->getBlogName());
MoblogLogger::log( "topic = ".$request->getTopic());
MoblogLogger::log( "reply to = ".$request->getReplyTo());
MoblogLogger::log( "body = ".$request->getBody());
$requestCategories = $request->getArticleCategories();
if(is_array($requestCategories)){
    foreach($requestCategories as $category){
        MoblogLogger::log( "request article category = $category");
    }
}
else{
    MoblogLogger::log( "request article category = $requestCategories");
}
MoblogLogger::log( "request global category = ".$request->getGlobalCategory());
    
    //
    // start processing the message...
    //
    
    //
    // first, try to authenticate the user
    //
$users = new Users();
if( $users->authenticateUser( $request->getUser(), $request->getPassword())) {
    $userInfo = $users->getUserInfoFromUsername( $request->getUser());
}
else {
    $response = new MoblogResponse( $request->getReplyTo(),
                                    "LifeType Moblog: Error",
                                    "User or password are not correct."
                                    );
    MoblogLogger::log( "User ".$request->getUser()." did not authenticate correctly." );
    $response->send();         
    return false;
}
    
    //
    // if user was authenticated, then proceed... and the first thing we should do
    // is see if the blog id is correct and if the user has permissions in that
    // blog
    //
$blogs = new Blogs();
if( $request->getBlogId() == "" ) {
        // user gave a blog name instead of a blog id (if he didn't, we'll get an error)
    $blogInfo = $blogs->getBlogInfoByName($request->getBlogName());
    if( !$blogInfo ) {
        $response = new MoblogResponse( $request->getReplyTo(),
                                        "LifeType Moblog: Error",
                                        "Incorrect blog name.  Please specify the blogId or blogName."
                                        );
        MoblogLogger::log( "Blog ".$request->getBlogName()." is not valid." );
        $response->send();         
        return false;    
    }
}
else {
        // TODO: we should check the blogDomain too -
        // that way the blogId / name doesn't have to be specified at all,
        // if the site is using custom domains.
    $blogInfo = $blogs->getBlogInfo( $request->getBlogId());
    if( !$blogInfo ) {
        $response = new MoblogResponse( $request->getReplyTo(),
                                        "LifeType Moblog: Error",
                                        "Incorrect blog identifier."
                                        );
        MoblogLogger::log( "Blog ".$request->getBlogId()." is not valid." );
        $response->send();         
        return false;    
    }
}
    
    //
    // check if the plugin has been enabled for this blog
    //
$blogSettings = $blogInfo->getSettings();
$pluginEnabled = $blogSettings->getValue( "plugin_moblog_enabled" );
if( !$pluginEnabled ) {
    $response = new MoblogResponse( $request->getReplyTo(),
                                    "LifeType Moblog: Error",
                                    "The plugin has not been enabled for this blog."
                                    );
    MoblogLogger::log( "Plugin not enabled for blog ".$request->getBlogId());
    $response->send();         
    return false;
}
    
    //
    // now check if the user is allowed to post in the given blog
    //
if( !$userInfo->hasPermissionByName( "add_post", $blogInfo->getId()) &&
    $blogInfo->getOwnerId() != $userInfo->getId()) {
    $response = new MoblogResponse( $request->getReplyTo(),
                                    "LifeType Moblog: Error",
                                    "You do not have permission to add posts to the given blog."
                                    );
    MoblogLogger::log( "User '".$request->getUser()."' does not have permission to add posts to blog ".$request->getBlogId());
    $response->send();         
    return false;
}

    // check the specified categories to make sure they exist
if(!$verifiedCategoryIds = getArticleCategories($request, $blogInfo))
    return false;

// globalCategoryId is optional in LifeType.  this will be set to false
// if it isn't specified (or is incorrect)
$globalCategoryId = getGlobalCategory($request, $blogSettings);

    // 
    // finally, add the resources to the database
    //

    // first, create a new album to hold these attachments
$albums = new GalleryAlbums();
$userAlbums = $albums->getUserAlbums( $blogInfo->getId());
$t = new Timestamp();    
$albumId = $blogSettings->getValue( "plugin_moblog_gallery_resource_album_id" );
$album = $albums->getAlbum( $albumId, $blogInfo->getId());
    // check if the album was loaded
if( !$album ) {
    $response = new MoblogResponse( $request->getReplyTo(),
                                    "LifeType Moblog: Error",
                                    "The album does not exist."
                                    );
    MoblogLogger::log( "User '".$request->getUser()."' tried to use album '".$albumId.
                       "' which does not exist.");
    $response->send(); 
    return false;                
}
MoblogLogger::log( "Adding resources to album ".$album->getName());    
    
$attachments = $request->getAttachments();
$res = new GalleryResources();
$resourceIds = Array();
    
if ( count($attachments) > 0) {
    foreach( $attachments as $attachment ) {
        MoblogLogger::log( "-- Processing attachment ".$attachment->getFileName()." - tmp filename = ".$attachment->getTmpName());
        $result = $res->addResourceFromDisk( $blogInfo->getId(), $albumId, $attachment->getFileName(), $attachment->getTmpName());
        MoblogLogger::log( "   Completed: result = $result" );
        if( $result ) {
                // keep this for later
            array_push( $resourceIds, $result );
        }
        else {
            MoblogLogger::log("false???");
        }
    }
}
else {
    MoblogLogger::log( "  No Attachments found" );
}
    
    //
    // if everything went fine, we can now proceed and publish the post, finally!!!! :)
    //
    
    // before adding the article, we need to add some additional markup 
    // with links to the attachments that were sent
$rg = $blogInfo->getBlogRequestGenerator();
$postBody = $request->getBody()."<br/>";
$numItems = count($resourceIds);
$curItem = 0;
foreach( $resourceIds as $resId ) {
    $resource = $res->getResource( $resId );
    $markup = "<a id=\"res_".$resId."\" href=\"".$rg->resourceLink( $resource )."\">";        
    if( $resource->isImage()) {
        $previewType = $blogSettings->getValue( "plugin_moblog_resource_preview_type" );
        if( $previewType == MOBLOG_EMBED_MEDIUM_PREVIEW ) {
            $link = $rg->resourceMediumSizePreviewLink( $resource );
            $cssClass = "res_image_medium";
        }
        elseif( $previewType == MOBLOG_EMBED_FULL_SIZE_VIEW ) {
            $link = $rg->resourceDownloadLink( $resource );
            $cssClass = "res_image";
        }
        else {
            $link = $rg->resourcePreviewLink( $resource );          
            $cssClass = "res_image_small";
        }
                
        $markup .= "<img class=\"$cssClass\" src=\"$link\" alt=\"".$resource->getDescription()."\" />";
    }
    else {
        $markup .= $resource->getDescription();
    }
    $markup .= "</a>";
    $curItem++;
    if( $curItem < $numItems ) 
        $markup .= "<br/><br/>";        
    MoblogLogger::log( "Adding markup $markup" );
    $postBody .= $markup;
    $postBody = TextFilter::autoP( trim( $postBody ));
    $resNames .= $resource->getDescription();        
}
    
    // add the article
$articles = new Articles();
$postTopic = $request->getTopic();

// some phones need this (I think only if the phone sends UTF-8 and the locale isn't in UTF-8 like in the German case)
// a little more testing, and I'll have this finally figured out.
//    $postTopic = utf8_decode($postTopic);
//    $postBody = utf8_decode($postBody);

$article = new Article( $postTopic, 
                        $postBody,
                        $verifiedCategoryIds,
                        $userInfo->getId(),
                        $blogInfo->getId(),
                        POST_STATUS_PUBLISHED,
                        0
                        );
$article->setDateObject( new Timestamp());
    // enable or disable comments by default depending on the current config
$commentsEnabled = $blogSettings->getValue( "comments_enabled" );
$article->setCommentsEnabled( $commentsEnabled );

if($globalCategoryId)
    $article->setGlobalCategoryId($globalCategoryId);

$result = $articles->addArticle( $article );
    
    // add an article notification
$notifications = new ArticleNotifications();
$notifications->addNotification( $result, $blogInfo->getId(), $userInfo->getId());

    // reset the cache in case it is enabled
CacheControl::resetBlogCache( $blogInfo->getId());
    
if( !$result ) {
    $response = new MoblogResponse( $request->getReplyTo(),
                                    "LifeType Moblog: Error",
                                    "There was an error adding the post to the database."
                                    );
    MoblogLogger::log( "There was an error adding the post to the database.");
}
else {
    lt_include( PLOG_CLASS_PATH."class/locale/ltlocales.class.php" );	
    $config =& Config::getConfig();
    $locale =& LTLocales::getLocale( $config->getValue("default_locale" ));
        
    $responseBody = $locale->pr("moblog_body",$request->getTopic());
    if( count($request->getAttachments()) > 0 ) {
        $responseBody .= $locale->tr("moblog_attachments");
        $responseBody .= $resNames;
    }
    $response = new MoblogResponse( $request->getReplyTo(), $locale->tr("moblog_mailsubject"), $responseBody ); 
    MoblogLogger::log( "Post was successfully added to the database." );

        // load the plugin manager, so the plugins can be notified if they want to
    $pm =& PluginManager::getPluginManager();
    $pm->setBlogInfo( $blogInfo);
    $pm->setUserInfo( $userInfo );
    $pm->loadPlugins( "index" );
        // Send the event so other folks know we just added an article
    $pm->notifyEvent( EVENT_POST_POST_ADD, Array( "article" => &$article ));
}
$response->send();
    
    // end of it...
MoblogLogger::log( "-- End");    



function getArticleCategories($request, $blogInfo){
    $blogSettings = $blogInfo->getSettings();
    
        // check the specified categories to make sure they exist
    $articleCategories = new ArticleCategories();    
        // load the category as defined in the plugin settings page
    $requestedCategoryIds = $blogSettings->getValue( "plugin_moblog_article_category_id" );
// old method is with just one category
    if(!is_array($requestedCategoryIds)){
        $requestedCategoryIds = array($requestedCategoryIds);
    }
    
    $verifiedSettingsCategoryIds = array();
    $verifiedEmailCategoryIds = array();
    foreach($requestedCategoryIds as $settingsCatId){
            // a "fake" category which means that the category will be specified
            // by the POSTed data.  (if "override" and other categories are specified,
            // it means that the category *might* be specified in the email)
        if($settingsCatId == -1){
            foreach($request->getArticleCategories() as $emailCatId){
                $category = $articleCategories->getCategory($emailCatId, $blogInfo->getId());
                if(!$category)
                    continue;
                $verifiedEmailCategoryIds[] = $category->getId();
            }
        }
        else{
            $category = $articleCategories->getCategory($settingsCatId, $blogInfo->getId());
            if(!$category)
                continue;
            $verifiedSettingsCategoryIds[] = $category->getId();
        }
    }
    
        // If the user specified categories in the email (and the blog settings allow them to override
        // the settings), they will take precedence
    if(count($verifiedEmailCategoryIds))
        $verifiedCategoryIds = $verifiedEmailCategoryIds;
    else
        $verifiedCategoryIds = $verifiedSettingsCategoryIds;
    
    if(!count($verifiedCategoryIds)){
            // if there was no such category, we should send an error and to make it more useful, send
            // as part of the error message the list of available categories
        $response = new MoblogResponse( $request->getReplyTo(),
                                        "LifeType Moblog: Error",
                                        "The categories do not exist."
                                        );
        $msg = "User '".$request->getUser()."' tried to use category: '";
        foreach($requestedCategoryIds as $catId){
            $msg .= $catId . ",";
        }
        $msg .= "' which does not exist.";
        MoblogLogger::log($msg);
        $response->send(); 
        return false;
    }
    
    foreach($verifiedCategoryIds as $catId){
        MoblogLogger::log( "final article category = $catId");
    }

    return $verifiedCategoryIds;
}



function getGlobalCategory($request, $blogSettings){
        // check the specified categories to make sure they exist
    $articleCategories = new GlobalArticleCategories();    
        // load the category as defined in the plugin settings page
    $settingsCategoryId = $blogSettings->getValue( "plugin_moblog_global_article_category_id" );
    $requestCategoryId = $request->getGlobalCategory();
    
        // a "fake" category which means that the category will be specified
        // by the POSTed data.
    if($settingsCategoryId == -1){
        $category = $articleCategories->getGlobalArticleCategory($requestCategoryId);
    }
    else{
        $category = $articleCategories->getGlobalArticleCategory($settingsCategoryId);
    }

    if(!$category){
            // if there was no such category, we should send an error and to make it more useful, send
            // as part of the error message the list of available categories
        $response = new MoblogResponse( $request->getReplyTo(),
                                        "LifeType Moblog: Error",
                                        "The global category does not exist."
                                        );
        $msg = "User '".$request->getUser()."' tried to use global category: '";
        if($settingCategoryId == -1)
            $msg .= "REQUEST: ".$requestCategoryId;
        else
            $msg .= "SETTINGS: ".$settingsCategoryId;
        $msg .= "' which does not exist.";
        MoblogLogger::log($msg);
        $response->send(); 
        return false;
    }
    
    MoblogLogger::log( "final global category = ".$category->getId());

    return $category->getId();
}
